/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   This file builds a nested model out of two copies of Model_2
   (so there are four copies of Model_1).

   You should draw a graph of the hierarchical (nested)
   structure of an instance of this model.
*/
public class Model_4 extends Model
{
   public Model_4()
   {
      super();

      Model m1 = new Model_2(Color.red, Color.black);
      Model m2 = new Model_2(Color.green, Color.blue);

      m1.modelTranslate(-2.0, -2.0, 0.0);

      m2.modelTranslate(2.0, 2.0, 0.0);
      m2.modelRotate(180.0, 0.0, 0.0, 1.0);

      this.addSubModel(m1);
      this.addSubModel(m2);
   }
}
