/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**

*/
public class ShowModel_4
{
   public static void main(String[] args)
   {
      Model m = new Model_4();

      // Create the Scene object that we shall render
      Scene scene = new Scene();

      // Add the model to the Scene.
      scene.modelList.add(m);


      // Create a Camera object.
      Camera camera = new Camera();

      // Add the Camera to the Scene.
      scene.setCamera(camera);


      // Create a framebuffer to render our scene into.
      int vp_width  = 512;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);

      for (int i = 0; i <= 36; i++)
      {
         m.model2Identity();
         // Push the model away from where the camera is.
         m.modelTranslate(0, 0, -8);

         m.modelRotate(10*i, 0, 0, 1);
         // Render again.
         fb.clearFB(java.awt.Color.white);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_ShowModel_4_Frame%02d.ppm", i));
      }
   }
}
