/*

*/
import scene.*;
import scene.models.*;
import pipeline.*;
import framebuffer.*;

import java.awt.Color;

/**
   Draw nine instances of Model_4 (where each instance
   of Model_4 contains four instances of Model_1).
*/
public class ShowNestedModels_36
{
   public static void main(String[] args)
   {
      Model m4 = new Model_4();

      Model nestedModels = new Model();

      nestedModels.addSubModel( m4 );

      /*
         Be sure to draw a picture of the graph that this code creates.
      */
      for (int i = 0; i < 8; i++)
      {
         Model subModel = new Model();
         subModel.modelRotate( i*45.0, 0,0,1);
         subModel.modelTranslate(0, -11, 0);
         subModel.modelScale(0.5, 0.5, 0.5);
         subModel.addSubModel( m4 );
         nestedModels.addSubModel( subModel );
      }


      // Create the Scene object that we shall render
      Scene scene = new Scene();

      // Add the model to the Scene.
      scene.modelList.add(nestedModels);


      // Create a Camera object.
      Camera camera = new Camera();

      // Add the Camera to the Scene.
      scene.setCamera(camera);


      // Create a framebuffer to render our scene into.
      int vp_width  = 512;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);

      for (int i = 0; i <= 36; i++)
      {
         nestedModels.model2Identity();
         // Push the model away from where the camera is.
         nestedModels.modelTranslate(0, 0, -15);

         nestedModels.modelRotate(10*i, 0, 0, 1);
//         m4.model2Identity();
//         m4.modelRotate(10*i, 0, 0,1);
         // Render again.
         fb.clearFB(java.awt.Color.white);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_ShowNestedModels_36_Frame%02d.ppm", i));
      }
   }
}
